package Allegory.Alleg;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Alleg.Lang.*;

public class DeptTable extends TaBle<Database,Dept,DeptTable> {
    @Override
    public String TupleTypeName() { return "Dept"; }

    public <TABLE> TABLE applyDept(Function<DeptTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public DeptTable(Database db) {
        this(db,null);
    }

    public DeptTable(Database db, Dept t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static DeptTable BaseRelation(Database db) {
        DeptTable tab = new DeptTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Dept> tuples() {
        return tuples;
    }

    @Override
    public DeptTable New() { return new DeptTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Dept r = new Dept(t.get("id"),t.get("name"),t.get("city"));
       r._inDiv = t.get("inDiv");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Dept t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Dept t) {
       db.Job.select(x->x.worksin==t).delete(); //b7
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Dept,[id,name,'city',inDiv:Div]).");
    }

    @Override
    public String pformat() { return Dept.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0;
       for (Dept a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.city).length()+2);
          f3 = Math.max(f3,a.inDiv.id.length());
       }
       return String.format("Dept(!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public STRINGTable city() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.city)));
       return st;
    }

    public EmpTable employs() {
       LinkedList<Dept> tups = tuples();
       EmpTable result = new EmpTable(db);
       for(Job r : db.Job.tuples()) {
          if(tups.contains(r.worksin) && !result.contains(r.employs)) {
             result.add(r.employs);
          }
       }
       return result; // nmLeft
    }

    public DivTable inDiv() {
       DivTable result = new DivTable(db);
       for (Dept w : tuples()) {
          if (!result.contains(w.inDiv))
              result.add(w.inDiv);
       }
       return result; // diamondLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
